Imports Microsoft
Imports System
Imports I8124_DotNET



Public Class Form1

    Dim cSlot As Byte

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ComboBox_Slot.SelectedIndex = 0
        cSlot = 0

    End Sub

    Private Sub Button_Active_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Active.Click

        cSlot = CByte(ComboBox_Slot.SelectedIndex)
        I8124SDK.I8124_ActiveModule(cSlot)

    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed

        I8124SDK.I8124_CloseModule(cSlot)

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_GetFirmwareVer.Click

        Dim Ret As UInteger

        Ret = I8124SDK.I8124_GetFirmwareVersion(CByte(ComboBox_Slot.SelectedIndex))
        MessageBox.Show("The I-8124 Firmware version is " + Convert.ToString(Ret, 16))

    End Sub

    Private Sub Button_MasterID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_MasterID.Click

        Dim MasterID As UInteger

        MasterID = I8124SDK.I8124_GetMasterMACID(CByte(ComboBox_Slot.SelectedIndex))
        If MasterID >= 64 Then
            MessageBox.Show("Get Master ID Error(" + CStr(MasterID) + ")!")
        Else
            ComboBox_MasterID.SelectedIndex = CInt(MasterID)
        End If

    End Sub

    Private Sub Button_SetMasterID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_SetMasterID.Click

        Dim MasterID, Ret As UInteger

        MasterID = CByte(ComboBox_MasterID.SelectedIndex)
        Ret = I8124SDK.I8124_SetMasterMACID(CByte(ComboBox_Slot.SelectedIndex), CByte(MasterID))
        If Ret <> 0 Then
            MessageBox.Show("Set Master ID Error(" + CStr(Ret) + ")!")
        Else
            MessageBox.Show("Set Master ID OK!")
        End If

    End Sub

    Private Sub Button_BaudRate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_BaudRate.Click

        Dim BaudRate As UInteger

        BaudRate = I8124SDK.I8124_GetBaudRate(CByte(ComboBox_Slot.SelectedIndex))
        If BaudRate >= 3 Then
            MessageBox.Show("Get Baud Rate Error(" + CStr(BaudRate) + ")!")
        Else
            ComboBox_BaudRate.SelectedIndex = CInt(BaudRate)
        End If

    End Sub

    Private Sub Button_SetBaudRate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_SetBaudRate.Click

        Dim BaudRate, Ret As UInteger

        BaudRate = CByte(ComboBox_BaudRate.SelectedIndex)
        Ret = I8124SDK.I8124_SetBaudRate(CByte(ComboBox_Slot.SelectedIndex), CByte(BaudRate))
        If Ret <> 0 Then
            MessageBox.Show("Set BaudRate Error(" + CStr(Ret) + ")!")
        Else
            MessageBox.Show("Set BaudRate OK!")
        End If

    End Sub

    Private Sub Button_ResetFirmware_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ResetFirmware.Click

        I8124SDK.I8124_ResetFirmware(CByte(ComboBox_Slot.SelectedIndex))

    End Sub

    Private Sub Button_SearchAllSlave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_SearchAllSlave.Click

        Dim Ret As UInteger

        Ret = I8124SDK.I8124_SearchAllDevices(CByte(ComboBox_Slot.SelectedIndex))
        If Ret <> 0 Then
            MessageBox.Show("Search All Slaves Error(" + CStr(Ret) + ")!")
        Else
            MessageBox.Show("Start to search all slave devices!" + Chr(10) + "Please wait for about 30 seconds!")
        End If

    End Sub

    Private Sub Button_GetAllSlaveInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_GetAllSlaveInfo.Click

        Dim Ret As UInteger
        Dim i, TotalDevices As UShort
        Dim DeviceInputLen(128) As UShort
        Dim DeviceOutputLen(128) As UShort
        Dim DesMACID(128) As Byte
        Dim Type(128) As Byte

        Ret = I8124SDK.I8124_IsSearchOK(CByte(ComboBox_Slot.SelectedIndex))
        If Ret = 1055 Then 'DNMXS_NowScanning
            MessageBox.Show("I-8124	is still searching the slave devices! Please wait!")
            Return
        ElseIf Ret <> 0 Then
            MessageBox.Show("There is an error!(" + CStr(Ret) + ")!")
            Return
        End If

        Ret = I8124SDK.I8124_GetSearchedDevices(CByte(ComboBox_Slot.SelectedIndex), TotalDevices, DesMACID, Type, DeviceInputLen, DeviceOutputLen)
        If Ret <> 0 Then
            MessageBox.Show("There is an error!(" + CStr(Ret) + ")!")
            Return
        End If

        ListBox_AllSlave.Items.Add("Slave ID  ,  I/O Type  ,  InputLen  , OutputLen")
        i = 0
        While i < TotalDevices

            Select Case Type(i)

                Case 0 'ConType_Explicit:
                    ListBox_AllSlave.Items.Add(CStr(DesMACID(i)) + ",  Explicit  ,    00    ,  00")

                Case 1 'ConType_Poll:
                    ListBox_AllSlave.Items.Add(CStr(DesMACID(i)) + ",  Poll  ,  " + CStr(DeviceInputLen(i)) + ",  " + CStr(DeviceOutputLen(i)))

                Case 2 'ConType_BitStrobe:
                    ListBox_AllSlave.Items.Add(CStr(DesMACID(i)) + ",  Strobe  ,  " + CStr(DeviceInputLen(i)) + ",  " + CStr(DeviceOutputLen(i)))

                Case 3 'ConType_COS:
                    ListBox_AllSlave.Items.Add(CStr(DesMACID(i)) + ",  COS  ,  " + CStr(DeviceInputLen(i)) + ",  " + CStr(DeviceOutputLen(i)))

                Case 4 'ConType_Cyclic:
                    ListBox_AllSlave.Items.Add(CStr(DesMACID(i)) + ",  Cyclic  ,  " + CStr(DeviceInputLen(i)) + ",  " + CStr(DeviceOutputLen(i)))

            End Select
            i = i + 1
        End While

    End Sub

End Class
