// Demo1_eVCDlg.cpp : implementation file
//

#include <windows.h>
#include "stdafx.h"
#include "Demo1_eVC.h"
#include "Demo1_eVCDlg.h"
#include "WinPACSDK.h"
#include "I8124API_eVC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemo1_eVCDlg dialog

CDemo1_eVCDlg::CDemo1_eVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo1_eVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo1_eVCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo1_eVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo1_eVCDlg)
	DDX_Control(pDX, IDC_LIST_ALL_SLAVES, m_AllSlaves);
	DDX_Control(pDX, IDC_COMBO_BAUDRATE, m_BaudRate);
	DDX_Control(pDX, IDC_COMBO_MASTER_MACID, m_MasterID);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo1_eVCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemo1_eVCDlg)
	ON_BN_CLICKED(IDC_BUTTON_FIRMWARE_VERSION, OnButtonFirmwareVersion)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_MASTER_MACID, OnButtonMasterMacid)
	ON_BN_CLICKED(IDC_BUTTON_BAUDRATE, OnButtonBaudrate)
	ON_BN_CLICKED(IDC_BUTTON_SET_MASTERID, OnButtonSetMasterid)
	ON_BN_CLICKED(IDC_BUTTON_SET_BAUDRATE, OnButtonSetBaudrate)
	ON_BN_CLICKED(IDC_BUTTON_RESET_FIRMWARE, OnButtonResetFirmware)
	ON_BN_CLICKED(IDC_BUTTON_AUTO_SEARCH, OnButtonAutoSearch)
	ON_BN_CLICKED(IDC_BUTTON_GET_SLAVE_INFO, OnButtonGetSlaveInfo)
	ON_CBN_SELENDOK(IDC_COMBO_SLOT, OnSelendokComboSlot)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo1_eVCDlg message handlers

BOOL CDemo1_eVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
    //Ret = I8124_ActiveModule(m_Slot.GetCurSel());
	//if(Ret) AfxMessageBox(_T("Open COM Error"));
	//m_Slot.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemo1_eVCDlg::OnButtonFirmwareVersion() 
{
   DWORD Ver = 0x0000;
   CString Str;
   Ver = I8124_GetFirmwareVersion(m_Slot.GetCurSel());	
   Str.Format(_T("Firmware Versior : %X.%02X"),(BYTE)(Ver>>8),(BYTE)(Ver&0x00FF));
   AfxMessageBox(Str);
}

void CDemo1_eVCDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	I8124_CloseModule(m_Slot.GetCurSel());
	CDialog::OnClose();
}

void CDemo1_eVCDlg::OnButtonMasterMacid() 
{
    DWORD MasterID;
	CString Str;
	MasterID = I8124_GetMasterMACID(m_Slot.GetCurSel());
	m_MasterID.SetCurSel(MasterID);
	if(MasterID >= 64)
	{
	  Str.Format(_T("Get Master MAC ID Error!(%d)"),MasterID);
	  AfxMessageBox(Str);
	}
}


void CDemo1_eVCDlg::OnButtonBaudrate() 
{
    DWORD BaudRate;
	CString Str;
	BaudRate = I8124_GetBaudRate(m_Slot.GetCurSel());	
	m_BaudRate.SetCurSel(BaudRate);
	if(BaudRate >= 64)
	{
	  Str.Format(_T("Get Baud Rate Error!(%d)"),BaudRate);
	  AfxMessageBox(Str);
	}
}

void CDemo1_eVCDlg::OnButtonSetMasterid() 
{
    DWORD Ret;
	CString Str;
    BYTE NewMasterID;
	NewMasterID = m_MasterID.GetCurSel();
	Ret = I8124_SetMasterMACID(m_Slot.GetCurSel(),NewMasterID);
	if(Ret)
	  Str.Format(_T("Set Master MAC ID Error!(%d)"),Ret);
    else
	  Str.Format(_T("Set Master MAC ID OK!"));
	AfxMessageBox(Str);	 	
}

void CDemo1_eVCDlg::OnButtonSetBaudrate() 
{
    DWORD Ret;
	CString Str;
	BYTE NewBaudRate;
	NewBaudRate = m_BaudRate.GetCurSel();
	Ret = I8124_SetBaudRate(m_Slot.GetCurSel(),NewBaudRate);
	if(Ret)
	  Str.Format(_T("Set Baud Rate Error!(%d)"),Ret);
    else
	  Str.Format(_T("Set Baud Rate OK!"));
	AfxMessageBox(Str);	 	
}

void CDemo1_eVCDlg::OnButtonResetFirmware() 
{
    I8124_ResetFirmware(m_Slot.GetCurSel());	
}

void CDemo1_eVCDlg::OnButtonAutoSearch() 
{
    DWORD Ret;
	CString Str;
	Ret = I8124_SearchAllDevices(m_Slot.GetCurSel());
	if(Ret)
	  Str.Format(_T("Search all slaves Error!(%d)"),Ret);
    else
	  Str.Format(_T("Start to search all slave devices!\r\n Please wait for about 30 seconds!"));
	AfxMessageBox(Str);			
}

void CDemo1_eVCDlg::OnButtonGetSlaveInfo() 
{
    DWORD Ret;
	CString Str;
	WORD i,TotalDevices,DeviceInputLen[128],DeviceOutputLen[128];
	BYTE DesMACID[128],Type[128];
	
	Ret = I8124_IsSearchOK(m_Slot.GetCurSel());
	if(Ret == DNMXS_NowScanning)
	{
	  AfxMessageBox(_T("I-87124	is still searching the slave devices! Please wait!"));
	  return;
	}
	else if(Ret)
	{
	  Str.Format(_T("There is an error!(%d)"),Ret);
	  AfxMessageBox(Str);
	  return;
	}
    
	Ret = I8124_GetSearchedDevices(m_Slot.GetCurSel(),&TotalDevices,DesMACID,Type,DeviceInputLen,DeviceOutputLen);
	if(Ret)
	{
	  Str.Format(_T("There is an error!(%d)"),Ret);
	  AfxMessageBox(Str);
	  return;
	}
	
	Str.Format(_T("Slave ID  ,  I/O Type  ,  InputLen  , OutputLen"));
	m_AllSlaves.AddString(Str);
	for(i = 0;i < TotalDevices;i++)
	{
	  switch(Type[i])
	  {
	    case ConType_Explicit:
	      Str.Format(_T("    %02d     ,      Explicit   ,       00        ,       00  "),DesMACID[i]);
		  break;  

		case ConType_Poll: 
	      Str.Format(_T("    %02d     ,      Poll       ,       %02d      ,       %02d  "),DesMACID[i],DeviceInputLen[i],DeviceOutputLen[i]);
		  break;

		case ConType_BitStrobe: 
	      Str.Format(_T("    %02d     ,      Strobe   ,       %02d      ,       %02d  "),DesMACID[i],DeviceInputLen[i],DeviceOutputLen[i]);
		  break;

		case ConType_COS: 
	      Str.Format(_T("    %02d     ,      COS      ,       %02d      ,       %02d  "),DesMACID[i],DeviceInputLen[i],DeviceOutputLen[i]);
		  break;  

		case ConType_Cyclic: 
	      Str.Format(_T("    %02d     ,      Cyclic     ,       %02d      ,       %02d  "),DesMACID[i],DeviceInputLen[i],DeviceOutputLen[i]);
		  break;
      }
      m_AllSlaves.AddString(Str);
	}
}

void CDemo1_eVCDlg::OnSelendokComboSlot() 
{
	// TODO: Add your control notification handler code here
    DWORD Ret;
	CString Str;
    Ret = I8124_ActiveModule(m_Slot.GetCurSel());

	if(Ret)
	{
	  Str.Format(_T("Active Error(%d)"),Ret);
	  AfxMessageBox(Str);
	}
	else
	  AfxMessageBox(_T("Active OK"));	
}
